| XMP Toolkit SDK 6.0.0

Public Member Functions | Protected Member Functions | List of all members
AdobeXMPCore::IDOMSerializer_v1 Class Referenceabstract

Version1 of the interface that represents an object that can serialize an XMP Data Model to a buffer. Provides the functions to serialize the XMP Data Model. More...

`#include <IDOMSerializer.h>`

Inheritance diagram for AdobeXMPCore::IDOMSerializer_v1:

## Public Member Functions
virtual spIUTF8String APICALL | Serialize (const spINode &node, const spcINameSpacePrefixMap &nameSpacePrefixMap=spcINameSpacePrefixMap())=0
| Serializes the given XMP Node into an IUTF8String object. More...
virtual spIDOMSerializer APICALL | Clone () const =0
| Virtual copy constructor. Creates an exact replica of the object. More...
Public Member Functions inherited from AdobeXMPCommon::IConfigurable
virtual bool APICALL | RemoveParameter (const uint64 &key)=0
| Removes a particular parameter if present. More...
virtual std::vector< uint64 > APICALL | GetAllParameters () const =0
| Get all the keys of the parameters associated with the object. More...
virtual sizet APICALL | Size () const __NOTHROW__=0
| Get the number of parameters associated with the object. More...
virtual eDataType APICALL | GetDataType (const uint64 &key) const =0
| Get the value type of a particular parameter. More...
virtual void APICALL | SetParameter (const uint64 &key, bool value)=0
| Add/Change a value of a parameter. More...
virtual void APICALL | SetParameter (const uint64 &key, uint64 value)=0
virtual void APICALL | SetParameter (const uint64 &key, int64 value)=0
virtual void APICALL | SetParameter (const uint64 &key, double value)=0
virtual void APICALL | SetParameter (const uint64 &key, char value)=0
virtual void APICALL | SetParameter (const uint64 &key, const char *value)=0
virtual void APICALL | SetParameter (const uint64 &key, const void *value)=0
virtual bool APICALL | GetParameter (const uint64 &key, bool &value) const =0
| Get the value of a parameter if present. More...
virtual bool APICALL | GetParameter (const uint64 &key, uint64 &value) const =0
virtual bool APICALL | GetParameter (const uint64 &key, int64 &value) const =0
virtual bool APICALL | GetParameter (const uint64 &key, double &value) const =0
virtual bool APICALL | GetParameter (const uint64 &key, char &value) const =0
virtual bool APICALL | GetParameter (const uint64 &key, const char *&value) const =0
virtual bool APICALL | GetParameter (const uint64 &key, const void *&value) const =0
Public Member Functions inherited from AdobeXMPCommon::ISharedObject
virtual void APICALL | Acquire () const __NOTHROW__=0
| Called by the clients of the object to indicate that he has acquired the shared ownership of the object. More...
virtual void APICALL | Release () const __NOTHROW__=0
| Called by the clients of the object to indicate he has released his shared ownership of the object. If this being the last client than this function should call Destroy to delete and release the memory. More...
Public Member Functions inherited from AdobeXMPCommon::IVersionable
template<typename requestedInterface >
XMP_PRIVATE requestedInterface * | GetInterfacePointer ()
| Get the raw pointer to an interface object implementing the requested version. More...
template<typename requestedInterface >
const XMP_PRIVATE requestedInterface * | GetInterfacePointer () const
| Get the raw pointer to a const interface object implementing the requested version. More...

## Protected Member Functions
virtual | ~IDOMSerializer_v1 () __NOTHROW__
Protected Member Functions inherited from AdobeXMPCommon::IConfigurable
virtual | ~IConfigurable () __NOTHROW__
| REQ_FRIEND_CLASS_DECLARATION ()
Protected Member Functions inherited from AdobeXMPCommon::ISharedObject
virtual | ~ISharedObject () __NOTHROW__=0
| REQ_FRIEND_CLASS_DECLARATION ()
Protected Member Functions inherited from AdobeXMPCommon::IVersionable
virtual | ~IVersionable ()
| REQ_FRIEND_CLASS_DECLARATION ()

## Additional Inherited Members
Public Types inherited from AdobeXMPCommon::IConfigurable
enum | eDataType { kDTNone = 0, kDTBool = 1 << 0, kDTUint64 = 1 << 1, kDTInt64 = 1 << 2, kDTChar = 1 << 3, kDTDouble = 1 << 4, kDTConstCharBuffer = 1 << 5, kDTConstVoidPtr = 1 << 6, kDTAll = 0xFFFFFFFF }
| Indicates various types of parameter values. More...
Static Public Member Functions inherited from AdobeXMPCommon::IConfigurable
static uint64 | ConvertCharBufferToUint64 (const char *key)
| Utility function to convert character buffer ( maximum of 8 characters ) to uint64 representation. More...

## Detailed Description

Version1 of the interface that represents an object that can serialize an XMP Data Model to a buffer. Provides the functions to serialize the XMP Data Model.

Definition at line 25 of file IDOMSerializer.h.

## Constructor & Destructor Documentation

## ◆ ~IDOMSerializer_v1()

virtual AdobeXMPCore::IDOMSerializer_v1::~IDOMSerializer_v1 | ( |  | ) |
| inline protected virtual

Destructor

Definition at line 106 of file IDOMSerializer.h.

106 {}

## Member Function Documentation

## ◆ Clone()

virtual spIDOMSerializer APICALL AdobeXMPCore::IDOMSerializer_v1::Clone | ( |  | ) | const
| pure virtual

Virtual copy constructor. Creates an exact replica of the object.

Returns
  A shared pointer to an object of #IDOMSerializer which is the exact replica of the current serializer.

## ◆ Serialize()

virtual spIUTF8String APICALL AdobeXMPCore::IDOMSerializer_v1::Serialize | ( | const spINode & | node,
|  | const spcINameSpacePrefixMap & | nameSpacePrefixMap = `spcINameSpacePrefixMap()`
| ) |  |
| pure virtual

Serializes the given XMP Node into an IUTF8String object.

Parameters

  [in] | node | An object of type #INode which needs to be serialized.
  [in] | nameSpacePrefixMap | An object of type #INameSpacePrefixMap which contains preferred prefixes for namespaces.

Returns
  An object of #AdobeXMPCommon::IUTF8String type containing the serialized form of the node.

The documentation for this class was generated from the following file:

- public/include/XMPCore/Interfaces/IDOMSerializer.h